A Steel Christmas Tree by Tekla Structures!

2
Written by [email protected] Monday, 20 December 2010 08:52 Cadmax keeps with tradition and created a new 3D Christmas design inspired by steel structure detailing. Following 2009’s candy canes, this year we have a steel tree to send our season’s greetings! Automation being a tradition as well, we made sure to use it as much as we could in our modeling. The key was to design the tree as a spiral by programming a Polybeam in C# through Tekla’s API.Net (the entire code is available at the bottom). The code generated a bunch of dots that spiraled around the trigonometric circle, from the tree’s top to its base. Unfortunately, Tekla’s Polybeams cannot integrate more than 99 dots. Thus, the sections toward the bottom of the tree are more edgy or jagged. Then, we just had to duplicate the spiral once and spin it on itself 180 degrees, to have a tree that’s more thick and dense. A large round HSS became the trunk and small beams were bolted at the base to serve as a stand. A few bolts were used as ornaments and a star made with contour plates complete the decorations. We worked with Tekla’s Beta version 17.0 to generate the final rendering, because it includes a new feature in the Part Representation: an almost unlimited palette of colours in 24 bit RGB. A nice forest green and the right shade of brown are finally available! If you can think it, we can model it. Here’s the spiral’s code : ----------------------------------- search... GO A first in Canada !!! API Programming IPD: Teaming up can lead to astounding results BIM VS NON-BIM Software 3D more expensive??? NO!!! Archives ▼ 2012 (3) ▼ June (1) A first in Canada !!! ► May (1) ► January (1) ► 2011 (10) A steel Christmas tree by Tekla Structures! 8/28/2012 http://www.cadmax.ca/en/learning-center/86-sapin-de-noe 1 / 2

description

Tekla Structures!

Transcript of A Steel Christmas Tree by Tekla Structures!

Page 1: A Steel Christmas Tree by Tekla Structures!

Written by [email protected] Monday, 20 December 2010 08:52

Cadmax keeps with tradition and created a new 3D Christmas design inspired by steelstructure detailing. Following 2009’s candy canes, this year we have a steel tree to send ourseason’s greetings!Automation being a tradition as well, we made sure to use it as much as we could in ourmodeling. The key was to design the tree as a spiral by programming a Polybeam in C#through Tekla’s API.Net (the entire code is available at the bottom).

The code generated a bunch of dots that spiraled around the trigonometric circle, from thetree’s top to its base. Unfortunately, Tekla’s Polybeams cannot integrate more than 99 dots.Thus, the sections toward the bottom of the tree are more edgy or jagged.

Then, we just had to duplicate the spiral once and spin it on itself 180 degrees, to have atree that’s more thick and dense. A large round HSS became the trunk and small beamswere bolted at the base to serve as a stand. A few bolts were used as ornaments and a starmade with contour plates complete the decorations.

We worked with Tekla’s Beta version 17.0 to generate the final rendering, because itincludes a new feature in the Part Representation: an almost unlimited palette of colours in24 bit RGB. A nice forest green and the right shade of brown are finally available! If you can think it, we can model it.

Here’s the spiral’s code :-----------------------------------

search... GO

A first in Canada !!!API ProgrammingIPD: Teaming up can lead to astounding resultsBIM VS NON-BIM Software3D more expensive??? NO!!!

Archives

▼ 2012 (3)▼ June (1)

• A first in Canada !!!► May (1)► January (1)

► 2011 (10)

A steel Christmas tree by Tekla Structures! 8/28/2012

http://www.cadmax.ca/en/learning-center/86-sapin-de-noe 1 / 2

Page 2: A Steel Christmas Tree by Tekla Structures!

using System;using System.Collections.Generic;using System.Linq;using System.Text;using Tekla.Structures;using Tekla.Structures.Model;

namespace sapin_noel_tekla{class Program{static void Main(string[] args){Tekla.Structures.Model.Model model = new Model();

PolyBeam pb = new PolyBeam( PolyBeam.PolyBeamTypeEnum.BEAM);

for (int i = 0; i < 99; i++){double z = 3000 - 30 * i;double angle = (Convert.ToDouble(i) % 20) * 18 / 180 * Math.PI;double dia = i * 10;

double x = dia * Math.Sin(angle);double y = dia * Math.Cos(angle);Tekla.Structures.Model.ContourPoint p = new ContourPoint(new Tekla.Structures.Geometry3d.Point(x,y,z), new Chamfer());

pb.Contour.AddContourPoint(p);}pb.Profile.ProfileString = "W4X13";pb.Insert();

model.CommitChanges();}}}Leave us your comments Last Updated on Monday, 17 January 2011 11:12

Home Services Achievements Learning Center Contact Us Client Zone

A steel Christmas tree by Tekla Structures! 8/28/2012

http://www.cadmax.ca/en/learning-center/86-sapin-de-noe 2 / 2